/*
   GEM resource example #1
   the resource file is handled in the normal way via rsrc_load etc.
   use DEFAULT.PRJ to compile
*/

#include <stdio.h>
#include <stdlib.h>
#include <aes.h>
#include <tos.h>

/* definitions of object numbers from ressource editor */
#include "example.h"

int ap_id;

int main(void)
{
	OBJECT *tree;
	char **str;
	int x,y,w,h; /* dialog box size & coordinates */
	int result; 
	
	ap_id = appl_init();
	if (ap_id < 0)
	{
		Cconws("appl_init() failed.");
		exit(1);
	}
	if(!rsrc_load("example.rsc"))
	{
		form_alert(1,"[3][error: cannot load EXAMPLE.RSC][Cancel]");
		appl_exit();
		exit(1);
	}
	graf_mouse(ARROW,NULL);
	rsrc_gaddr(0,TREE1,&tree); /* get address of main tree */

	/* prepare dialog handling */
	form_center(tree,&x,&y,&w,&h);
	form_dial(FMD_START,x,y,w,h,x,y,w,h);
	objc_draw(tree,0,10,x,y,w,h);
	result = form_do(tree,EDIT1);
	form_dial(FMD_FINISH,x,y,w,h,x,y,w,h);
  /* de-select exit object */
  tree[result&0x7FFF].ob_state &= ~SELECTED;

	/* get ptr to address of free string (alert box) */
	/* other free strings can be accessed in a similar way */
	rsrc_gaddr(15,ALERT1,&str);
	/* display alert box defined in ressource */
	form_alert(1,*str);
	
	rsrc_free();
	appl_exit();
	return 0;
}
