/*
   GEM resource example #3
   the ressource data is converted to a file EXAMPLE.C. This file is
   compiled separately and linked together with the main program. This
   saved time, especially in big programs, because the ressource data
   is not compiled after every change in the main program.
   
   use option 'C' to create the EXAMPLE.C file from the EXAMPLE.RSH
   output of the RCS
   use EXAMPLE3.PRJ to compile
*/

#include <stdio.h>
#include <stdlib.h>
#include <aes.h>
#include <tos.h>

/* definitions of object numbers from ressource editor */
#include "example.h"

int ap_id;

/* definitions of structures from ressource module EXAMPLE.C */
extern char *rs_frstr[];
extern BITBLK rs_bitblk[];
extern ICONBLK rs_iconblk[];
extern TEDINFO rs_tedinfo[];
extern OBJECT rs_object[];
extern OBJECT *rs_trindex[];
/* ressource init routine, also from EXAMPLE.C */
extern void rsrc_init(void);

/* from now on, the code is identical to the one used in EXAMPLE2.C */

int main(void)
{
	OBJECT *tree;
	char *str;
	int x,y,w,h; /* dialog box size & coordinates */
	int result; 
	
	ap_id = appl_init();
	if (ap_id < 0)
	{
		Cconws("appl_init() failed.");
		exit(1);
	}
	graf_mouse(ARROW,NULL);
	rsrc_init();               /* initialize included ressource data */
	tree = rs_trindex[TREE1];  /* get address of main tree */

	/* prepare dialog handling */
	form_center(tree,&x,&y,&w,&h);
	form_dial(FMD_START,x,y,w,h,x,y,w,h);
	objc_draw(tree,0,10,x,y,w,h);
	result = form_do(tree,EDIT1);
	form_dial(FMD_FINISH,x,y,w,h,x,y,w,h);
  /* de-select exit object */
  tree[result&0x7FFF].ob_state &= ~SELECTED;

	/* get ptr to address of free string (alert box) */
	/* other free strings can be accessed in a similar way */
	str = rs_frstr[ALERT1];
	/* display alert box defined in ressource */
	form_alert(1,str);
	
	appl_exit();
	return 0;
}
